/*
 * Copyright (c) 2013, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package com.javafx.experiments.dukepad.compass.imu;

public class DmpKey {
    public static final short DINA0A = 0x0a;
    public static final short DINA22 = 0x22;
    public static final short DINA42 = 0x42;
    public static final short DINA5A = 0x5a;

    public static final short DINA06 = 0x06;
    public static final short DINA0E = 0x0e;
    public static final short DINA16 = 0x16;
    public static final short DINA1E = 0x1e;
    public static final short DINA26 = 0x26;
    public static final short DINA2E = 0x2e;
    public static final short DINA36 = 0x36;
    public static final short DINA3E = 0x3e;
    public static final short DINA46 = 0x46;
    public static final short DINA4E = 0x4e;
    public static final short DINA56 = 0x56;
    public static final short DINA5E = 0x5e;
    public static final short DINA66 = 0x66;
    public static final short DINA6E = 0x6e;
    public static final short DINA76 = 0x76;
    public static final short DINA7E = 0x7e;

    public static final short DINA00 = 0x00;
    public static final short DINA08 = 0x08;
    public static final short DINA10 = 0x10;
    public static final short DINA18 = 0x18;
    public static final short DINA20 = 0x20;
    public static final short DINA28 = 0x28;
    public static final short DINA30 = 0x30;
    public static final short DINA38 = 0x38;
    public static final short DINA40 = 0x40;
    public static final short DINA48 = 0x48;
    public static final short DINA50 = 0x50;
    public static final short DINA58 = 0x58;
    public static final short DINA60 = 0x60;
    public static final short DINA68 = 0x68;
    public static final short DINA70 = 0x70;
    public static final short DINA78 = 0x78;

    public static final short DINA04 = 0x04;
    public static final short DINA0C = 0x0c;
    public static final short DINA14 = 0x14;
    public static final short DINA1C = 0x1C;
    public static final short DINA24 = 0x24;
    public static final short DINA2C = 0x2c;
    public static final short DINA34 = 0x34;
    public static final short DINA3C = 0x3c;
    public static final short DINA44 = 0x44;
    public static final short DINA4C = 0x4c;
    public static final short DINA54 = 0x54;
    public static final short DINA5C = 0x5c;
    public static final short DINA64 = 0x64;
    public static final short DINA6C = 0x6c;
    public static final short DINA74 = 0x74;
    public static final short DINA7C = 0x7c;

    public static final short DINA01 = 0x01;
    public static final short DINA09 = 0x09;
    public static final short DINA11 = 0x11;
    public static final short DINA19 = 0x19;
    public static final short DINA21 = 0x21;
    public static final short DINA29 = 0x29;
    public static final short DINA31 = 0x31;
    public static final short DINA39 = 0x39;
    public static final short DINA41 = 0x41;
    public static final short DINA49 = 0x49;
    public static final short DINA51 = 0x51;
    public static final short DINA59 = 0x59;
    public static final short DINA61 = 0x61;
    public static final short DINA69 = 0x69;
    public static final short DINA71 = 0x71;
    public static final short DINA79 = 0x79;

    public static final short DINA25 = 0x25;
    public static final short DINA2D = 0x2d;
    public static final short DINA35 = 0x35;
    public static final short DINA3D = 0x3d;
    public static final short DINA4D = 0x4d;
    public static final short DINA55 = 0x55;
    public static final short DINA5D = 0x5D;
    public static final short DINA6D = 0x6d;
    public static final short DINA75 = 0x75;
    public static final short DINA7D = 0x7d;

    public static final short DINADC = 0xdc;
    public static final short DINAF2 = 0xf2;
    public static final short DINAAB = 0xab;
    public static final short DINAAA = 0xaa;
    public static final short DINAF1 = 0xf1;
    public static final short DINADF = 0xdf;
    public static final short DINADA = 0xda;
    public static final short DINAB1 = 0xb1;
    public static final short DINAB9 = 0xb9;
    public static final short DINAF3 = 0xf3;
    public static final short DINA8B = 0x8b;
    public static final short DINAA3 = 0xa3;
    public static final short DINA91 = 0x91;
    public static final short DINAB6 = 0xb6;
    public static final short DINAB4 = 0xb4;


    public static final short DINC00 = 0x00;
    public static final short DINC01 = 0x01;
    public static final short DINC02 = 0x02;
    public static final short DINC03 = 0x03;
    public static final short DINC08 = 0x08;
    public static final short DINC09 = 0x09;
    public static final short DINC0A = 0x0a;
    public static final short DINC0B = 0x0b;
    public static final short DINC10 = 0x10;
    public static final short DINC11 = 0x11;
    public static final short DINC12 = 0x12;
    public static final short DINC13 = 0x13;
    public static final short DINC18 = 0x18;
    public static final short DINC19 = 0x19;
    public static final short DINC1A = 0x1a;
    public static final short DINC1B = 0x1b;

    public static final short DINC20 = 0x20;
    public static final short DINC21 = 0x21;
    public static final short DINC22 = 0x22;
    public static final short DINC23 = 0x23;
    public static final short DINC28 = 0x28;
    public static final short DINC29 = 0x29;
    public static final short DINC2A = 0x2a;
    public static final short DINC2B = 0x2b;
    public static final short DINC30 = 0x30;
    public static final short DINC31 = 0x31;
    public static final short DINC32 = 0x32;
    public static final short DINC33 = 0x33;
    public static final short DINC38 = 0x38;
    public static final short DINC39 = 0x39;
    public static final short DINC3A = 0x3a;
    public static final short DINC3B = 0x3b;

    public static final short DINC40 = 0x40;
    public static final short DINC41 = 0x41;
    public static final short DINC42 = 0x42;
    public static final short DINC43 = 0x43;
    public static final short DINC48 = 0x48;
    public static final short DINC49 = 0x49;
    public static final short DINC4A = 0x4a;
    public static final short DINC4B = 0x4b;
    public static final short DINC50 = 0x50;
    public static final short DINC51 = 0x51;
    public static final short DINC52 = 0x52;
    public static final short DINC53 = 0x53;
    public static final short DINC58 = 0x58;
    public static final short DINC59 = 0x59;
    public static final short DINC5A = 0x5a;
    public static final short DINC5B = 0x5b;

    public static final short DINC60 = 0x60;
    public static final short DINC61 = 0x61;
    public static final short DINC62 = 0x62;
    public static final short DINC63 = 0x63;
    public static final short DINC68 = 0x68;
    public static final short DINC69 = 0x69;
    public static final short DINC6A = 0x6a;
    public static final short DINC6B = 0x6b;
    public static final short DINC70 = 0x70;
    public static final short DINC71 = 0x71;
    public static final short DINC72 = 0x72;
    public static final short DINC73 = 0x73;
    public static final short DINC78 = 0x78;
    public static final short DINC79 = 0x79;
    public static final short DINC7A = 0x7a;
    public static final short DINC7B = 0x7b;

    public static final short DIND40 = 0x40;


    public static final short DINA80 = 0x80;
    public static final short DINA90 = 0x90;
    public static final short DINAA0 = 0xa0;
    public static final short DINAC9 = 0xc9;
    public static final short DINACB = 0xcb;
    public static final short DINACD = 0xcd;
    public static final short DINACF = 0xcf;
    public static final short DINAC8 = 0xc8;
    public static final short DINACA = 0xca;
    public static final short DINACC = 0xcc;
    public static final short DINACE = 0xce;
    public static final short DINAD8 = 0xd8;
    public static final short DINADD = 0xdd;
    public static final short DINAF8 = 0xf0;
    public static final short DINAFE = 0xfe;

    public static final short DINBF8 = 0xf8;
    public static final short DINAC0 = 0xb0;
    public static final short DINAC1 = 0xb1;
    public static final short DINAC2 = 0xb4;
    public static final short DINAC3 = 0xb5;
    public static final short DINAC4 = 0xb8;
    public static final short DINAC5 = 0xb9;
    public static final short DINBC0 = 0xc0;
    public static final short DINBC2 = 0xc2;
    public static final short DINBC4 = 0xc4;
    public static final short DINBC6 = 0xc6;
}
