/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.scene.effect;

/**
Builder class for javafx.scene.effect.BoxBlur
@see javafx.scene.effect.BoxBlur
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public class BoxBlurBuilder<B extends javafx.scene.effect.BoxBlurBuilder<B>> implements javafx.util.Builder<javafx.scene.effect.BoxBlur> {
    protected BoxBlurBuilder() {
    }

    /** Creates a new instance of BoxBlurBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.scene.effect.BoxBlurBuilder<?> create() {
        return new javafx.scene.effect.BoxBlurBuilder();
    }

    private int __set;
    public void applyTo(javafx.scene.effect.BoxBlur x) {
        int set = __set;
        if ((set & (1 << 0)) != 0) x.setHeight(this.height);
        if ((set & (1 << 1)) != 0) x.setInput(this.input);
        if ((set & (1 << 2)) != 0) x.setIterations(this.iterations);
        if ((set & (1 << 3)) != 0) x.setWidth(this.width);
    }

    private double height;
    /**
    Set the value of the {@link javafx.scene.effect.BoxBlur#getHeight() height} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B height(double x) {
        this.height = x;
        __set |= 1 << 0;
        return (B) this;
    }

    private javafx.scene.effect.Effect input;
    /**
    Set the value of the {@link javafx.scene.effect.BoxBlur#getInput() input} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B input(javafx.scene.effect.Effect x) {
        this.input = x;
        __set |= 1 << 1;
        return (B) this;
    }

    private int iterations;
    /**
    Set the value of the {@link javafx.scene.effect.BoxBlur#getIterations() iterations} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B iterations(int x) {
        this.iterations = x;
        __set |= 1 << 2;
        return (B) this;
    }

    private double width;
    /**
    Set the value of the {@link javafx.scene.effect.BoxBlur#getWidth() width} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B width(double x) {
        this.width = x;
        __set |= 1 << 3;
        return (B) this;
    }

    /**
    Make an instance of {@link javafx.scene.effect.BoxBlur} based on the properties set on this builder.
    */
    public javafx.scene.effect.BoxBlur build() {
        javafx.scene.effect.BoxBlur x = new javafx.scene.effect.BoxBlur();
        applyTo(x);
        return x;
    }
}
