/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.scene.image;

/**
Builder class for javafx.scene.image.ImageView
@see javafx.scene.image.ImageView
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public class ImageViewBuilder<B extends javafx.scene.image.ImageViewBuilder<B>> extends javafx.scene.NodeBuilder<B> implements javafx.util.Builder<javafx.scene.image.ImageView> {
    protected ImageViewBuilder() {
    }

    /** Creates a new instance of ImageViewBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.scene.image.ImageViewBuilder<?> create() {
        return new javafx.scene.image.ImageViewBuilder();
    }

    private int __set;
    private void __set(int i) {
        __set |= 1 << i;
    }
    public void applyTo(javafx.scene.image.ImageView x) {
        super.applyTo(x);
        int set = __set;
        while (set != 0) {
            int i = Integer.numberOfTrailingZeros(set);
            set &= ~(1 << i);
            switch (i) {
                case 0: x.setFitHeight(this.fitHeight); break;
                case 1: x.setFitWidth(this.fitWidth); break;
                case 2: x.setImage(this.image); break;
                case 3: x.setPreserveRatio(this.preserveRatio); break;
                case 4: x.setSmooth(this.smooth); break;
                case 5: x.setViewport(this.viewport); break;
                case 6: x.setX(this.x); break;
                case 7: x.setY(this.y); break;
            }
        }
    }

    private double fitHeight;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#getFitHeight() fitHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B fitHeight(double x) {
        this.fitHeight = x;
        __set(0);
        return (B) this;
    }

    private double fitWidth;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#getFitWidth() fitWidth} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B fitWidth(double x) {
        this.fitWidth = x;
        __set(1);
        return (B) this;
    }

    private javafx.scene.image.Image image;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#getImage() image} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B image(javafx.scene.image.Image x) {
        this.image = x;
        __set(2);
        return (B) this;
    }

    private boolean preserveRatio;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#isPreserveRatio() preserveRatio} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B preserveRatio(boolean x) {
        this.preserveRatio = x;
        __set(3);
        return (B) this;
    }

    private boolean smooth;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#isSmooth() smooth} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B smooth(boolean x) {
        this.smooth = x;
        __set(4);
        return (B) this;
    }

    private javafx.geometry.Rectangle2D viewport;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#getViewport() viewport} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B viewport(javafx.geometry.Rectangle2D x) {
        this.viewport = x;
        __set(5);
        return (B) this;
    }

    private double x;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#getX() x} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B x(double x) {
        this.x = x;
        __set(6);
        return (B) this;
    }

    private double y;
    /**
    Set the value of the {@link javafx.scene.image.ImageView#getY() y} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B y(double x) {
        this.y = x;
        __set(7);
        return (B) this;
    }

    /**
    Make an instance of {@link javafx.scene.image.ImageView} based on the properties set on this builder.
    */
    public javafx.scene.image.ImageView build() {
        javafx.scene.image.ImageView x = new javafx.scene.image.ImageView();
        applyTo(x);
        return x;
    }
}
