/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.scene.layout;

/**
Builder class for javafx.scene.layout.RowConstraints
@see javafx.scene.layout.RowConstraints
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public class RowConstraintsBuilder<B extends javafx.scene.layout.RowConstraintsBuilder<B>> implements javafx.util.Builder<javafx.scene.layout.RowConstraints> {
    protected RowConstraintsBuilder() {
    }

    /** Creates a new instance of RowConstraintsBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.scene.layout.RowConstraintsBuilder<?> create() {
        return new javafx.scene.layout.RowConstraintsBuilder();
    }

    private int __set;
    public void applyTo(javafx.scene.layout.RowConstraints x) {
        int set = __set;
        if ((set & (1 << 0)) != 0) x.setFillHeight(this.fillHeight);
        if ((set & (1 << 1)) != 0) x.setMaxHeight(this.maxHeight);
        if ((set & (1 << 2)) != 0) x.setMinHeight(this.minHeight);
        if ((set & (1 << 3)) != 0) x.setPercentHeight(this.percentHeight);
        if ((set & (1 << 4)) != 0) x.setPrefHeight(this.prefHeight);
        if ((set & (1 << 5)) != 0) x.setValignment(this.valignment);
        if ((set & (1 << 6)) != 0) x.setVgrow(this.vgrow);
    }

    private boolean fillHeight;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#isFillHeight() fillHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B fillHeight(boolean x) {
        this.fillHeight = x;
        __set |= 1 << 0;
        return (B) this;
    }

    private double maxHeight;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#getMaxHeight() maxHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B maxHeight(double x) {
        this.maxHeight = x;
        __set |= 1 << 1;
        return (B) this;
    }

    private double minHeight;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#getMinHeight() minHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B minHeight(double x) {
        this.minHeight = x;
        __set |= 1 << 2;
        return (B) this;
    }

    private double percentHeight;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#getPercentHeight() percentHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B percentHeight(double x) {
        this.percentHeight = x;
        __set |= 1 << 3;
        return (B) this;
    }

    private double prefHeight;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#getPrefHeight() prefHeight} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B prefHeight(double x) {
        this.prefHeight = x;
        __set |= 1 << 4;
        return (B) this;
    }

    private javafx.geometry.VPos valignment;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#getValignment() valignment} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B valignment(javafx.geometry.VPos x) {
        this.valignment = x;
        __set |= 1 << 5;
        return (B) this;
    }

    private javafx.scene.layout.Priority vgrow;
    /**
    Set the value of the {@link javafx.scene.layout.RowConstraints#getVgrow() vgrow} property for the instance constructed by this builder.
    */
    @SuppressWarnings("unchecked")
    public B vgrow(javafx.scene.layout.Priority x) {
        this.vgrow = x;
        __set |= 1 << 6;
        return (B) this;
    }

    /**
    Make an instance of {@link javafx.scene.layout.RowConstraints} based on the properties set on this builder.
    */
    public javafx.scene.layout.RowConstraints build() {
        javafx.scene.layout.RowConstraints x = new javafx.scene.layout.RowConstraints();
        applyTo(x);
        return x;
    }
}
