/*
 * Copyright (c) 2011, 2014, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * This code is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License version 2 only, as
 * published by the Free Software Foundation.  Oracle designates this
 * particular file as subject to the "Classpath" exception as provided
 * by Oracle in the LICENSE file that accompanied this code.
 *
 * This code is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * version 2 for more details (a copy is included in the LICENSE file that
 * accompanied this code).
 *
 * You should have received a copy of the GNU General Public License version
 * 2 along with this work; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
 * or visit www.oracle.com if you need additional information or have any
 * questions.
 */

package javafx.scene.media;

/**
Builder class for javafx.scene.media.AudioClip
@see javafx.scene.media.AudioClip
@deprecated This class is deprecated and will be removed in the next version
* @since JavaFX 2.0
*/
@javax.annotation.Generated("Generated by javafx.builder.processor.BuilderProcessor")
@Deprecated
public final class AudioClipBuilder implements javafx.util.Builder<javafx.scene.media.AudioClip> {
    protected AudioClipBuilder() {
    }

    /** Creates a new instance of AudioClipBuilder. */
    @SuppressWarnings({"deprecation", "rawtypes", "unchecked"})
    public static javafx.scene.media.AudioClipBuilder create() {
        return new javafx.scene.media.AudioClipBuilder();
    }

    private int __set;
    public void applyTo(javafx.scene.media.AudioClip x) {
        int set = __set;
        if ((set & (1 << 0)) != 0) x.setBalance(this.balance);
        if ((set & (1 << 1)) != 0) x.setCycleCount(this.cycleCount);
        if ((set & (1 << 2)) != 0) x.setPan(this.pan);
        if ((set & (1 << 3)) != 0) x.setPriority(this.priority);
        if ((set & (1 << 4)) != 0) x.setRate(this.rate);
        if ((set & (1 << 5)) != 0) x.setVolume(this.volume);
    }

    private double balance;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getBalance() balance} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder balance(double x) {
        this.balance = x;
        __set |= 1 << 0;
        return this;
    }

    private int cycleCount;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getCycleCount() cycleCount} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder cycleCount(int x) {
        this.cycleCount = x;
        __set |= 1 << 1;
        return this;
    }

    private double pan;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getPan() pan} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder pan(double x) {
        this.pan = x;
        __set |= 1 << 2;
        return this;
    }

    private int priority;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getPriority() priority} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder priority(int x) {
        this.priority = x;
        __set |= 1 << 3;
        return this;
    }

    private double rate;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getRate() rate} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder rate(double x) {
        this.rate = x;
        __set |= 1 << 4;
        return this;
    }

    private java.lang.String source;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getSource() source} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder source(java.lang.String x) {
        this.source = x;
        return this;
    }

    private double volume;
    /**
    Set the value of the {@link javafx.scene.media.AudioClip#getVolume() volume} property for the instance constructed by this builder.
    */
    public javafx.scene.media.AudioClipBuilder volume(double x) {
        this.volume = x;
        __set |= 1 << 5;
        return this;
    }

    /**
    Make an instance of {@link javafx.scene.media.AudioClip} based on the properties set on this builder.
    */
    public javafx.scene.media.AudioClip build() {
        javafx.scene.media.AudioClip x = new javafx.scene.media.AudioClip(this.source);
        applyTo(x);
        return x;
    }
}
