/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#ifndef WebKitDOMTestCallbackFunction_h
#define WebKitDOMTestCallbackFunction_h

#ifdef WEBKIT_DOM_USE_UNSTABLE_API

#include <glib-object.h>
#include <webkitdom/WebKitDOMObject.h>
#include <webkitdom/webkitdomdefines-unstable.h>

G_BEGIN_DECLS

#define WEBKIT_DOM_TYPE_TEST_CALLBACK_FUNCTION            (webkit_dom_test_callback_function_get_type())
#define WEBKIT_DOM_TEST_CALLBACK_FUNCTION(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_DOM_TYPE_TEST_CALLBACK_FUNCTION, WebKitDOMTestCallbackFunction))
#define WEBKIT_DOM_TEST_CALLBACK_FUNCTION_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_DOM_TYPE_TEST_CALLBACK_FUNCTION, WebKitDOMTestCallbackFunctionClass)
#define WEBKIT_DOM_IS_TEST_CALLBACK_FUNCTION(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_DOM_TYPE_TEST_CALLBACK_FUNCTION))
#define WEBKIT_DOM_IS_TEST_CALLBACK_FUNCTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_DOM_TYPE_TEST_CALLBACK_FUNCTION))
#define WEBKIT_DOM_TEST_CALLBACK_FUNCTION_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_DOM_TYPE_TEST_CALLBACK_FUNCTION, WebKitDOMTestCallbackFunctionClass))

struct _WebKitDOMTestCallbackFunction {
    WebKitDOMObject parent_instance;
};

struct _WebKitDOMTestCallbackFunctionClass {
    WebKitDOMObjectClass parent_class;
};

WEBKIT_API GType
webkit_dom_test_callback_function_get_type(void);

/**
 * webkit_dom_test_callback_function_callback_with_no_param:
 * @self: A #WebKitDOMTestCallbackFunction
 *
 * Returns: A #gboolean
 *
 * Stability: Unstable
**/
WEBKIT_API gboolean
webkit_dom_test_callback_function_callback_with_no_param(WebKitDOMTestCallbackFunction* self);

/**
 * webkit_dom_test_callback_function_callback_with_array_param:
 * @self: A #WebKitDOMTestCallbackFunction
 * @arrayParam: A #WebKitDOMFloat32Array
 *
 * Returns: A #gboolean
 *
 * Stability: Unstable
**/
WEBKIT_API gboolean
webkit_dom_test_callback_function_callback_with_array_param(WebKitDOMTestCallbackFunction* self, WebKitDOMFloat32Array* arrayParam);

/**
 * webkit_dom_test_callback_function_callback_with_serialized_script_value_param:
 * @self: A #WebKitDOMTestCallbackFunction
 * @srzParam: A #gchar
 * @strArg: A #gchar
 *
 * Returns: A #gboolean
 *
 * Stability: Unstable
**/
WEBKIT_API gboolean
webkit_dom_test_callback_function_callback_with_serialized_script_value_param(WebKitDOMTestCallbackFunction* self, const gchar* srzParam, const gchar* strArg);

/**
 * webkit_dom_test_callback_function_callback_with_non_bool_return_type:
 * @self: A #WebKitDOMTestCallbackFunction
 * @strArg: A #gchar
 *
 * Returns: A #glong
 *
 * Stability: Unstable
**/
WEBKIT_API glong
webkit_dom_test_callback_function_callback_with_non_bool_return_type(WebKitDOMTestCallbackFunction* self, const gchar* strArg);

/**
 * webkit_dom_test_callback_function_callback_with_string_list:
 * @self: A #WebKitDOMTestCallbackFunction
 * @listParam: A #WebKitDOMDOMStringList
 *
 * Returns: A #gboolean
 *
 * Stability: Unstable
**/
WEBKIT_API gboolean
webkit_dom_test_callback_function_callback_with_string_list(WebKitDOMTestCallbackFunction* self, WebKitDOMDOMStringList* listParam);

/**
 * webkit_dom_test_callback_function_callback_with_boolean:
 * @self: A #WebKitDOMTestCallbackFunction
 * @boolParam: A #gboolean
 *
 * Returns: A #gboolean
 *
 * Stability: Unstable
**/
WEBKIT_API gboolean
webkit_dom_test_callback_function_callback_with_boolean(WebKitDOMTestCallbackFunction* self, gboolean boolParam);

/**
 * webkit_dom_test_callback_function_callback_requires_this_to_pass:
 * @self: A #WebKitDOMTestCallbackFunction
 * @longParam: A #glong
 * @testNodeParam: A #WebKitDOMTestNode
 *
 * Returns: A #gboolean
 *
 * Stability: Unstable
**/
WEBKIT_API gboolean
webkit_dom_test_callback_function_callback_requires_this_to_pass(WebKitDOMTestCallbackFunction* self, glong longParam, WebKitDOMTestNode* testNodeParam);

G_END_DECLS

#endif /* WEBKIT_DOM_USE_UNSTABLE_API */
#endif /* WebKitDOMTestCallbackFunction_h */
