/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#include "config.h"
#include "WebKitDOMTestClassWithJSBuiltinConstructor.h"

#include "CSSImportRule.h"
#include "DOMObjectCache.h"
#include "Document.h"
#include "ExceptionCode.h"
#include "ExceptionCodeDescription.h"
#include "JSMainThreadExecState.h"
#include "WebKitDOMPrivate.h"
#include "WebKitDOMTestClassWithJSBuiltinConstructorPrivate.h"
#include "gobject/ConvertToUTF8String.h"
#include <wtf/GetPtr.h>
#include <wtf/RefPtr.h>

#define WEBKIT_DOM_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR_GET_PRIVATE(obj) G_TYPE_INSTANCE_GET_PRIVATE(obj, WEBKIT_DOM_TYPE_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR, WebKitDOMTestClassWithJSBuiltinConstructorPrivate)

typedef struct _WebKitDOMTestClassWithJSBuiltinConstructorPrivate {
    RefPtr<WebCore::TestClassWithJSBuiltinConstructor> coreObject;
} WebKitDOMTestClassWithJSBuiltinConstructorPrivate;

namespace WebKit {

WebKitDOMTestClassWithJSBuiltinConstructor* kit(WebCore::TestClassWithJSBuiltinConstructor* obj)
{
    if (!obj)
        return 0;

    if (gpointer ret = DOMObjectCache::get(obj))
        return WEBKIT_DOM_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR(ret);

    return wrapTestClassWithJSBuiltinConstructor(obj);
}

WebCore::TestClassWithJSBuiltinConstructor* core(WebKitDOMTestClassWithJSBuiltinConstructor* request)
{
    return request ? static_cast<WebCore::TestClassWithJSBuiltinConstructor*>(WEBKIT_DOM_OBJECT(request)->coreObject) : 0;
}

WebKitDOMTestClassWithJSBuiltinConstructor* wrapTestClassWithJSBuiltinConstructor(WebCore::TestClassWithJSBuiltinConstructor* coreObject)
{
    ASSERT(coreObject);
    return WEBKIT_DOM_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR(g_object_new(WEBKIT_DOM_TYPE_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR, "core-object", coreObject, nullptr));
}

} // namespace WebKit

G_DEFINE_TYPE(WebKitDOMTestClassWithJSBuiltinConstructor, webkit_dom_test_class_with_js_builtin_constructor, WEBKIT_DOM_TYPE_OBJECT)

static void webkit_dom_test_class_with_js_builtin_constructor_finalize(GObject* object)
{
    WebKitDOMTestClassWithJSBuiltinConstructorPrivate* priv = WEBKIT_DOM_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR_GET_PRIVATE(object);

    WebKit::DOMObjectCache::forget(priv->coreObject.get());

    priv->~WebKitDOMTestClassWithJSBuiltinConstructorPrivate();
    G_OBJECT_CLASS(webkit_dom_test_class_with_js_builtin_constructor_parent_class)->finalize(object);
}

static GObject* webkit_dom_test_class_with_js_builtin_constructor_constructor(GType type, guint constructPropertiesCount, GObjectConstructParam* constructProperties)
{
    GObject* object = G_OBJECT_CLASS(webkit_dom_test_class_with_js_builtin_constructor_parent_class)->constructor(type, constructPropertiesCount, constructProperties);

    WebKitDOMTestClassWithJSBuiltinConstructorPrivate* priv = WEBKIT_DOM_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR_GET_PRIVATE(object);
    priv->coreObject = static_cast<WebCore::TestClassWithJSBuiltinConstructor*>(WEBKIT_DOM_OBJECT(object)->coreObject);
    WebKit::DOMObjectCache::put(priv->coreObject.get(), object);

    return object;
}

static void webkit_dom_test_class_with_js_builtin_constructor_class_init(WebKitDOMTestClassWithJSBuiltinConstructorClass* requestClass)
{
    GObjectClass* gobjectClass = G_OBJECT_CLASS(requestClass);
    g_type_class_add_private(gobjectClass, sizeof(WebKitDOMTestClassWithJSBuiltinConstructorPrivate));
    gobjectClass->constructor = webkit_dom_test_class_with_js_builtin_constructor_constructor;
    gobjectClass->finalize = webkit_dom_test_class_with_js_builtin_constructor_finalize;
}

static void webkit_dom_test_class_with_js_builtin_constructor_init(WebKitDOMTestClassWithJSBuiltinConstructor* request)
{
    WebKitDOMTestClassWithJSBuiltinConstructorPrivate* priv = WEBKIT_DOM_TEST_CLASS_WITH_JS_BUILTIN_CONSTRUCTOR_GET_PRIVATE(request);
    new (priv) WebKitDOMTestClassWithJSBuiltinConstructorPrivate();
}

