/*
 *  This file is part of the WebKit open source project.
 *  This file has been generated by generate-bindings.pl. DO NOT MODIFY!
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 *  You should have received a copy of the GNU Library General Public License
 *  along with this library; see the file COPYING.LIB.  If not, write to
 *  the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301, USA.
 */

#ifndef WebKitDOMTestInterface_h
#define WebKitDOMTestInterface_h

#ifdef WEBKIT_DOM_USE_UNSTABLE_API

#include <glib-object.h>
#include <webkitdom/WebKitDOMObject.h>
#include <webkitdom/webkitdomdefines-unstable.h>

G_BEGIN_DECLS

#define WEBKIT_DOM_TYPE_TEST_INTERFACE            (webkit_dom_test_interface_get_type())
#define WEBKIT_DOM_TEST_INTERFACE(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), WEBKIT_DOM_TYPE_TEST_INTERFACE, WebKitDOMTestInterface))
#define WEBKIT_DOM_TEST_INTERFACE_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  WEBKIT_DOM_TYPE_TEST_INTERFACE, WebKitDOMTestInterfaceClass)
#define WEBKIT_DOM_IS_TEST_INTERFACE(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), WEBKIT_DOM_TYPE_TEST_INTERFACE))
#define WEBKIT_DOM_IS_TEST_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  WEBKIT_DOM_TYPE_TEST_INTERFACE))
#define WEBKIT_DOM_TEST_INTERFACE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  WEBKIT_DOM_TYPE_TEST_INTERFACE, WebKitDOMTestInterfaceClass))

#if ENABLE(Condition22) || ENABLE(Condition23)
/**
 * WEBKIT_DOM_TEST_INTERFACE_IMPLEMENTSCONSTANT1:
 */
#define WEBKIT_DOM_TEST_INTERFACE_IMPLEMENTSCONSTANT1 1
#endif /* ENABLE(Condition22) || ENABLE(Condition23) */

#if ENABLE(Condition22) || ENABLE(Condition23)
/**
 * WEBKIT_DOM_TEST_INTERFACE_IMPLEMENTSCONSTANT2:
 */
#define WEBKIT_DOM_TEST_INTERFACE_IMPLEMENTSCONSTANT2 2
#endif /* ENABLE(Condition22) || ENABLE(Condition23) */

#if ENABLE(Condition11) || ENABLE(Condition12)
/**
 * WEBKIT_DOM_TEST_INTERFACE_SUPPLEMENTALCONSTANT1:
 */
#define WEBKIT_DOM_TEST_INTERFACE_SUPPLEMENTALCONSTANT1 1
#endif /* ENABLE(Condition11) || ENABLE(Condition12) */

#if ENABLE(Condition11) || ENABLE(Condition12)
/**
 * WEBKIT_DOM_TEST_INTERFACE_SUPPLEMENTALCONSTANT2:
 */
#define WEBKIT_DOM_TEST_INTERFACE_SUPPLEMENTALCONSTANT2 2
#endif /* ENABLE(Condition11) || ENABLE(Condition12) */

struct _WebKitDOMTestInterface {
    WebKitDOMObject parent_instance;
};

struct _WebKitDOMTestInterfaceClass {
    WebKitDOMObjectClass parent_class;
};

WEBKIT_API GType
webkit_dom_test_interface_get_type(void);

/**
 * webkit_dom_test_interface_implements_method1:
 * @self: A #WebKitDOMTestInterface
 *
 * Stability: Unstable
**/
WEBKIT_API void
webkit_dom_test_interface_implements_method1(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_implements_method2:
 * @self: A #WebKitDOMTestInterface
 * @strArg: A #gchar
 * @objArg: A #WebKitDOMTestObj
 * @error: #GError
 *
 * Returns: (transfer none): A #WebKitDOMTestObj
 *
 * Stability: Unstable
**/
WEBKIT_API WebKitDOMTestObj*
webkit_dom_test_interface_implements_method2(WebKitDOMTestInterface* self, const gchar* strArg, WebKitDOMTestObj* objArg, GError** error);

/**
 * webkit_dom_test_interface_supplemental_method1:
 * @self: A #WebKitDOMTestInterface
 *
 * Stability: Unstable
**/
WEBKIT_API void
webkit_dom_test_interface_supplemental_method1(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_supplemental_method2:
 * @self: A #WebKitDOMTestInterface
 * @strArg: A #gchar
 * @objArg: A #WebKitDOMTestObj
 * @error: #GError
 *
 * Returns: (transfer none): A #WebKitDOMTestObj
 *
 * Stability: Unstable
**/
WEBKIT_API WebKitDOMTestObj*
webkit_dom_test_interface_supplemental_method2(WebKitDOMTestInterface* self, const gchar* strArg, WebKitDOMTestObj* objArg, GError** error);

/**
 * webkit_dom_test_interface_get_implements_str1:
 * @self: A #WebKitDOMTestInterface
 *
 * Returns: A #gchar
 *
 * Stability: Unstable
**/
WEBKIT_API gchar*
webkit_dom_test_interface_get_implements_str1(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_get_implements_str2:
 * @self: A #WebKitDOMTestInterface
 *
 * Returns: A #gchar
 *
 * Stability: Unstable
**/
WEBKIT_API gchar*
webkit_dom_test_interface_get_implements_str2(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_set_implements_str2:
 * @self: A #WebKitDOMTestInterface
 * @value: A #gchar
 *
 * Stability: Unstable
**/
WEBKIT_API void
webkit_dom_test_interface_set_implements_str2(WebKitDOMTestInterface* self, const gchar* value);

/**
 * webkit_dom_test_interface_get_implements_node:
 * @self: A #WebKitDOMTestInterface
 *
 * Returns: (transfer none): A #WebKitDOMNode
 *
 * Stability: Unstable
**/
WEBKIT_API WebKitDOMNode*
webkit_dom_test_interface_get_implements_node(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_set_implements_node:
 * @self: A #WebKitDOMTestInterface
 * @value: A #WebKitDOMNode
 *
 * Stability: Unstable
**/
WEBKIT_API void
webkit_dom_test_interface_set_implements_node(WebKitDOMTestInterface* self, WebKitDOMNode* value);

/**
 * webkit_dom_test_interface_get_supplemental_str1:
 * @self: A #WebKitDOMTestInterface
 *
 * Returns: A #gchar
 *
 * Stability: Unstable
**/
WEBKIT_API gchar*
webkit_dom_test_interface_get_supplemental_str1(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_get_supplemental_str2:
 * @self: A #WebKitDOMTestInterface
 *
 * Returns: A #gchar
 *
 * Stability: Unstable
**/
WEBKIT_API gchar*
webkit_dom_test_interface_get_supplemental_str2(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_set_supplemental_str2:
 * @self: A #WebKitDOMTestInterface
 * @value: A #gchar
 *
 * Stability: Unstable
**/
WEBKIT_API void
webkit_dom_test_interface_set_supplemental_str2(WebKitDOMTestInterface* self, const gchar* value);

/**
 * webkit_dom_test_interface_get_supplemental_node:
 * @self: A #WebKitDOMTestInterface
 *
 * Returns: (transfer none): A #WebKitDOMNode
 *
 * Stability: Unstable
**/
WEBKIT_API WebKitDOMNode*
webkit_dom_test_interface_get_supplemental_node(WebKitDOMTestInterface* self);

/**
 * webkit_dom_test_interface_set_supplemental_node:
 * @self: A #WebKitDOMTestInterface
 * @value: A #WebKitDOMNode
 *
 * Stability: Unstable
**/
WEBKIT_API void
webkit_dom_test_interface_set_supplemental_node(WebKitDOMTestInterface* self, WebKitDOMNode* value);

G_END_DECLS

#endif /* WEBKIT_DOM_USE_UNSTABLE_API */
#endif /* WebKitDOMTestInterface_h */
